-- 幻灵属性

Lua_EidolonAttrPanel = class("Lua_EidolonAttrPanel", Lua_DragContainerItem);
function Lua_EidolonAttrPanel:ctor(p)
    self.height = 220;
    self:superCall("ctor", p);

end

function Lua_EidolonAttrPanel:setData(param)
    if (self.itemArr == nil) then
        self.itemArr = Array();
        for i = 1, param:getSize() do
            local item = Lua_EidolonAttrItem.new(self.content);
            self.itemArr:add(item);
        end
    end

    local dis = 12;
    local lastItemPos = 0;
    local lastItemHeight = 0;
    self.height = 16 + dis * 5;
    for i = 1, self.itemArr:getSize() do
        self.itemArr[i]:setData(param[i]);
        if (i == 1) then
            -- self.itemArr[i].content.transform.localPosition = Vector3(-170, 55)
            LuaUtil.setObjPos(self.itemArr[i].content, -170, 55, 0);
        else
            -- self.itemArr[i].content.transform.localPosition = Vector3(-170, lastItemPos.y - lastItemHeight-3, 0);
            LuaUtil.setObjPos(self.itemArr[i].content, -170, lastItemPos.y - lastItemHeight-3, 0);
        end
        lastItemPos = self.itemArr[i].content.transform.localPosition;
        lastItemHeight = self.itemArr[i]:getHeight();
        self.height = self.height + self.itemArr[i]:getHeight();
    end

    self.height = 96 - lastItemPos.y + lastItemHeight;
end

function Lua_EidolonAttrPanel:getHeight()
    return self.height;
end













Lua_EidolonAttrItem = class("Lua_EidolonAttrItem", Lua_DisplayObject);
function Lua_EidolonAttrItem:ctor(p)
    self:superCall("ctor", p, "EidolonAttItem_skin");
end

function Lua_EidolonAttrItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_EidolonAttrItem:setData(data)
    self.data = data;

    self.att_name.text = data.attr_name .. "：";
    self.att_prop.text = data.attr_num;

    local labelTrans = self.att_name.mainContent.transform;
    local txtTrans = self.att_prop.mainContent.transform;
    -- txtTrans.localPosition = Vector3(labelTrans.localPosition.x + self.att_name.width, labelTrans.localPosition.y, 0);
    LuaUtil.setTfPos(txtTrans, labelTrans.localPosition.x + self.att_name.width, labelTrans.localPosition.y);
    local subObjTrans = self.subObj.transform;
    -- subObjTrans.localPosition = Vector3(txtTrans.localPosition.x + self.att_prop.width + 40, txtTrans.localPosition.y, 0);
    LuaUtil.setTfPos(subObjTrans, txtTrans.localPosition.x + self.att_prop.width + 40, txtTrans.localPosition.y, 0);

    self.height = 24;
    if data.attr_add == nil then
        self.subObj:SetActive(false);
    else
        self.subObj:SetActive(true);
        self.add_prop.text = data.attr_add;
        if (subObjTrans.localPosition.x + 28 + self.add_prop.uiwidget.width > 382) then
            -- self.subObj.transform.localPosition = Vector3(txtTrans.localPosition.x, -27, 0);
            LuaUtil.setObjPos(self.subObj, txtTrans.localPosition.x, -27, 0);
            self.height = 51;
        end
    end
end

function Lua_EidolonAttrItem:getHeight()
    return self.height;
end

function Lua_EidolonAttrItem:dispose()
    self:superCall("dispose");
end