-- 幻灵/星灵系统
checkRequire("Lua_EidolonPanel"); -- 幻灵
checkRequire("Lua_StarSpiritPanel"); -- 星灵
Lua_EidolonWindow = class("Lua_EidolonWindow", Lua_FullSizeTabWindow);
function Lua_EidolonWindow:ctor()
	self.list = Array();
	self.list:add({name = LanUtil.getValue(142001), eventIds = {14034, 14035}, openId = 10214, panel = Lua_StarSpiritPanel, titleAltas = "titleName_altas_1", titleSprite = "xingling"});
	self.list:add({name = LanUtil.getValue(142000), eventIds = {14031, 14032, 14033}, openId = 10215, panel = Lua_EidolonPanel, titleAltas = "titleName_altas_1", titleSprite = "huanling"});

	self:superCall("ctor", self.list);
	self.windowName = "Lua_EidolonWindow";
end

function Lua_EidolonWindow:showWin(param)
	if type(param) == "table" and param.openIdx ~= nil then
		self.isSetIndex = true;
		self.btnList:setSelected(param.openIdx, true);
	elseif type(param) == "number" then
		self.isSetIndex = true;
		self.btnList:setSelected(param, true);
	end
end

function Lua_EidolonWindow:dispose()
	DataCenter.eidolonData.eidolonSelectIndex = 1;
	self:superCall("dispose");
end