-- 幻灵属性总览
Lua_EidolonPropertyWindow = class("Lua_EidolonPropertyWindow", Lua_Window);
function Lua_EidolonPropertyWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_EidolonPropertyWindow";
	self.skinName = "EidolonProperty_skin";
	self.blackAlpha = 1 / 255;
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_EidolonPropertyWindow:buildShowItem()
	self:superCall("buildShowItem");

	-- self.content.transform.localPosition = Vector3(-67, -23, 0);
	LuaUtil.setObjPos(self.content, -67, -23, 0);

	self.textArea = Lua_TextArea.new(self.content, 308, 310);
	self.textArea:setLocation(-137, 168, 0);
	self.textArea.insideItem.label.fontSize = 24;
	self.textArea.insideItem.label.spacingY = 3;
	self.textArea:setText(DataCenter.eidolonData.getAttName);

	self.fore.text = LanUtil.formateStr(LanUtil.getValue(142004), tostring(DataCenter.eidolonData.getEidolonAllRore));
end

function Lua_EidolonPropertyWindow:dispose()
	if self.textArea ~= nil then
		self.textArea:dispose();
		self.textArea = nil;
	end

	self:superCall("dispose");
end