-- 幻灵技能描述
Lua_EidolonSkillWindow = class("Lua_EidolonSkillWindow", Lua_Window);
function Lua_EidolonSkillWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_EidolonSkillWindow";
	self.skinName = "EidolonSkillWindow_skill"; 
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_EidolonSkillWindow:buildShowItem()
	self:superCall("buildShowItem");

	-- self.content.transform.localPosition = Vector3(-70, 0, 0);
	LuaUtil.setObjPos(self.content, -70, 0, 0);
end

function Lua_EidolonSkillWindow:showWin(param)
	self.skillNameLab.text = param.skillVo.name;
	self.skillTypeLab.text = param.skill_type;
	self.desTxt1.text = param.base_des;
	self.tipsLab.text = param.getBackLvl;
	self.skillIcon:setAltas(tostring(param.skillVo.atlas), tostring(param.skillVo.skillIcon));

	if param.activate == 0 then
		self.nextDesObj:SetActive(false);
		self.maxObj:SetActive(false);
		self.tipsLab:setEnable(true);
	else
		if param.is_max_lvl == true then
			self.nextDesObj:SetActive(false);
			self.maxObj:SetActive(true);
			self.tipsLab:setEnable(false);
		else
			self.nextDesObj:SetActive(true);
			self.maxObj:SetActive(false);
			self.tipsLab:setEnable(true);

			self.desTxt2.text = param.next_des;
		end
	end
end